import javax.naming.*;
import java.util.Properties;
import java.util.Enumeration;
import java.util.Hashtable;
import java.io.*;
import org.exolab.castor.xml.MarshalException;
import org.exolab.castor.xml.ValidationException;

import org.gxos.*;
import org.gxos.config.GXOSConfiguration;
import org.gxos.schema.*;
import org.gxos.schema.types.*;
import org.gxos.debug.Log;
import org.gxos.gndi.context.*;
import org.gxos.xml.*;
import org.gxos.util.*;

import garnet.gateway.schema.*;

public class TestGX {

    PrintWriter out = new PrintWriter(System.out);

  public TestGX(Properties env) {

	try {
            ContextManager.initialize(env);
            XMLObject gateway = ContextManager.getDatabase("Gateway");
/********
    Application a = (Application)Defaults.initEntity(new Application(), "Ising_demo",
        NodeTypeType.COLLECTION, NodeRootingType.INTERNALNODE);

    a.setComment("this is a comment string");
    a.setParameters(new Parameters());
    CustomParameters.setValue(a.getParameters(), "NoOfInParams", "1");

    Machine m = new Machine();
    m.setName("dirac");
    m.setParameters(new Parameters());
    CustomParameters.setValue(m.getParameters(), "HostName", "dirac.csit.fsu.edu");
    a.addMachine(m);

    m = new Machine();
    m.setName("birch");
    m.setParameters(new Parameters());
    CustomParameters.setValue(m.getParameters(), "HostName", "birch.csit.fsu.edu");
    CustomParameters.setValue(m.getParameters(), "QueueType", "DQS");
    CustomParameters.setValue(m.getParameters(), "CLASSPATH", "/users/cyoun");
    a.addMachine(m);

    VisualizationToolkit vtk = new VisualizationToolkit();
    vtk.setName("gnuplot");
    CustomParameters.setValue(vtk.getParameters(), "VizName", "gnuplot");
    CustomParameters.setValue(vtk.getParameters(), "VizHostName", "zeus.csit.fsu.edu");
    a.addVisualizationToolkit(vtk);
    */
/*    ApplicationDescription ad = (ApplicationDescription)Defaults.initEntity(
        new ApplicationDescription(), "descriptions", NodeTypeType.COLLECTION,
        NodeRootingType.LEAF);

    ad.setComment("this description comment");

            gateway.addObject(ad); */

            /*XMLObject ad = gateway.getChild("descriptions");
             ad.addObject(a);*/

            System.out.println(gateway.getXML());
        }catch(Exception e) {
            e.printStackTrace();
        }
    }

    public void report(TreeObject t) {

    PrintWriter pw = new PrintWriter(System.out);
    try {

      System.out.println("\nObject marshalled:\n");
      t.marshal(pw);

    } catch (MarshalException me) {
      System.out.println("Marshal exception: "+me.getMessage());
    } catch (ValidationException ve) {
      System.out.println("Validation exception: "+ve.getMessage());
    } catch (Exception e) {
      System.out.println("Exception: "+e.getMessage());
    }
    System.out.print("\n\n");
  }


  public static void main(String[] args) {
 
    try {

        String configFile = "gxos.conf";
        Properties env = Defaults.getConfiguration(configFile);
        TestGX test1 = new TestGX(env);

    } catch(Exception e) {
        e.printStackTrace();
    }
  }
}




